<?php /*

#
#   Sample vlogin user to service level map
#
#   One user name per line - user name comes first, followed by
#   any amount of whitespace, and then the target service level 
#   name as such:
#   
#      mary@mydomain.com    basic
#      jose@mydomain.com    premium
#
#   Note that the service level value can be anything you want
#   it to be, as long as a corresponding file for that service
#   level is found in the config/config_vlogin or
#   plugins/vlogin/data/service_levels directory.  For example,
#   config overrides for the two users above would be found in
#   config/config_vlogin/service_levels/basic.php and
#   config/config_vlogin/service_levels/premium.php OR in
#   plugins/vlogin/data/service_levels/basic.php and
#   plugins/vlogin/data/service_levels/premium.php.  See the sample 
#   service level config override file provided in that directory.
#
#   Also note that user names can contain the wildcards * and ? 
#   which indicate "any number of (or zero) characters" and "one 
#   alphanumeric character" respectively.  
#
#   For example, the user name "jose_r*@domain.com" would match 
#   the user name "jose_rodriguez@domain.com" as well as 
#   "jose_riviera@domain.com".  "jose?@domain.com" would match 
#   "jose5@domain.com", but not "jose@domain.com", although the 
#   pattern "jose*@domain.com" would match both "jose5@domain.com" 
#   and "jose@domain.com".
#
#   Finally, note that if a user name listed in this file also 
#   matches one or more user name patterns, the exact match takes 
#   precedence, so you may provide patterns with special overrides.
#

# example
#
user1@domain.com   premium


# wildcard example
#
user?@domain.*   basic



*/
